----------------------------------------------------------------------------------
-- Company: FRI
-- Engineer: Miha Moskon
-- 
-- Create Date:    08:22:05 10/05/2007 
-- Design Name: 
-- Module Name:    btn_pressed - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity btn_pressed is
	port (
		CLK_in	: in	STD_LOGIC;
		RST_in	: in	STD_LOGIC;
		BTN_in	: in	STD_LOGIC;
		SIG_out	: out	STD_LOGIC);
end btn_pressed;

architecture Behavioral of btn_pressed is
	type STATES is (S1, S2);
	signal currSt, nextSt	:	STATES;
	
	signal nextOut	: STD_LOGIC;
	signal BTN, zero: STD_LOGIC;
	signal q: STD_LOGIC_VECTOR(22 downto 0);

begin

	zero <= '1' when (q = conv_std_logic_vector(0,23)) else '0';
	BTN <= '1' when (q = conv_std_logic_vector(0,23)) and (BTN_in = '1') else '0';
	
	process (CLK_in)
	begin
		if (rising_edge(CLK_in)) then
			if (RST_in = '1') then
				q <= conv_std_logic_vector(4999999,23); -- 100 ms
			else
				if (BTN_in = '1') then
					if (zero = '0') then
						q <= q - 1;
					else
						q <= (others => '0');
					end if;
				else
					q <= conv_std_logic_vector(4999999,23); -- 100 ms
				end if;
			end if;
		end if;
	end process;
		
	process (CLK_in)
	begin
		if (rising_edge(CLK_in)) then
			if (RST_in = '1') then
				currSt	<=	S1;
				SIG_out  <= '0';
			else
				currSt	<= nextSt;
				SIG_out	<= nextOut;			
			end if;	
		end if;	
	end process;


	-- Mealyjev avtomat
	process (BTN, currSt)
	begin
		case currSt is
			when S1	=>
				if (BTN = '1') then
					nextSt	<= S2;
					nextOut	<= '1';
				else
					nextSt	<= S1;
					nextOut	<= '0';
				end if;
			
			when S2	=>
				if (BTN = '1')	then
					nextSt	<= S2;
					nextOut	<= '0';
				else
					nextSt	<= S1;
					nextOut	<= '0';
				end if;
		end case;
	end process;



end Behavioral;

