----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    11:29:23 12/11/2009 
-- Design Name: 
-- Module Name:    control_unit_top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity control_unit_top is
	PORT(
		CLK_in		: IN std_logic;		
		RST_in		: IN std_logic;
		BTN_E_in		: IN std_logic;
		BTN_S_in		: IN std_logic;
		BTN_N_in		: IN std_logic;
		TXD_out		: OUT std_logic
		);

end control_unit_top;

architecture Behavioral of control_unit_top is


	-- COMPONENTS

	COMPONENT rs232_top
	PORT(
		CLK_in : IN std_logic;
		RST_in : IN std_logic;
		VALUE_in : IN std_logic_vector(7 downto 0);
		WE_in : IN std_logic;          
		TXD_out : OUT std_logic
		);
	END COMPONENT;

	COMPONENT btn_pressed
	PORT(
		CLK_in : IN std_logic;
		RST_in : IN std_logic;
		BTN_in : IN std_logic;          
		SIG_out : OUT std_logic
		);
	END COMPONENT;
	
	COMPONENT char_counter
	PORT(
		CLK_in : IN std_logic;
		RST_in : IN std_logic;
		UP_in : IN std_logic;
		DOWN_in : IN std_logic;          
		CHAR_out : OUT std_logic_vector(7 downto 0)
		);
	END COMPONENT;

	signal WE						: std_logic;
	signal BTN_E, BTN_N, BTN_S : std_logic;
	signal CHAR						: std_logic_vector(7 downto 0);

begin

	WE	<= BTN_E;

	-- COMPONENT INSTANTIATION
	Inst_rs232_top: rs232_top PORT MAP(
		CLK_in => CLK_in,
		RST_in => RST_in,
		VALUE_in => CHAR,
		WE_in => WE,
		TXD_out => TXD_out
	);

	BUTTON_S: btn_pressed PORT MAP(
		CLK_in => CLK_in,
		RST_in => RST_in,
		BTN_in => BTN_S_in,
		SIG_out => BTN_S
	);
	
	BUTTON_N: btn_pressed PORT MAP(
		CLK_in => CLK_in,
		RST_in => RST_in,
		BTN_in => BTN_N_in,
		SIG_out => BTN_N
	);
	
	BUTTON_E: btn_pressed PORT MAP(
		CLK_in => CLK_in,
		RST_in => RST_in,
		BTN_in => BTN_E_in,
		SIG_out => BTN_E
	);
	
	Inst_char_counter: char_counter PORT MAP(
		CLK_in => CLK_in,
		RST_in => RST_in,
		UP_in => BTN_N,
		DOWN_in => BTN_S,
		CHAR_out => CHAR
	);




end Behavioral;

