----------------------------------------------------------------------------------
-- Company: 
-- Engineer: 
-- 
-- Create Date:    13:00:36 12/14/2007 
-- Design Name: 
-- Module Name:    rs232_top - Behavioral 
-- Project Name: 
-- Target Devices: 
-- Tool versions: 
-- Description: 
--
-- Dependencies: 
--
-- Revision: 
-- Revision 0.01 - File Created
-- Additional Comments: 
--
----------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

---- Uncomment the following library declaration if instantiating
---- any Xilinx primitives in this code.
--library UNISIM;
--use UNISIM.VComponents.all;

entity rs232_top is
	PORT(
		CLK_in		: IN std_logic;		
		RST_in		: IN std_logic;
		VALUE_in		: IN std_logic_vector(7 downto 0);
		WE_in			: IN std_logic;
		TXD_out		: OUT std_logic
	);
end rs232_top;

architecture Behavioral of rs232_top is

-- KOMPONENTE
	-- generator pulzov
	COMPONENT pulse_gen
	GENERIC(
			size : integer := 8
			 );	 
	PORT(
		CLK_in : IN std_logic;
		RST_in : IN std_logic;
		VALUE_in : IN std_logic_vector(size-1 downto 0);          
		SIG_out : OUT std_logic
		);
	END COMPONENT;
	
	-- 10-bitni pomikalni register
	COMPONENT shift_reg
	PORT(
		CLK_in : IN std_logic;
		RST_in : IN std_logic;
		CE_in	: IN std_logic;
		WE_in : IN std_logic;
		VALUE_in : IN std_logic_vector(8 downto 0);          
		BIT_out : OUT std_logic
		);
	END COMPONENT;
	
	
-- SIGNALI	
	signal pulse				: std_logic;
	signal tmp_val_in			: std_logic_vector(8 downto 0);

begin


-- INSTANCE KOMPONENT

	-- generator pulzov
	Inst_pulse_gen: pulse_gen 
	GENERIC MAP(
		size => 16
	)	
	PORT MAP(
		CLK_in => CLK_in,
		RST_in => RST_in,
		VALUE_in => conv_std_logic_vector(41667,16),	-- pri hitrosti 1200 b/s moramo uro deliti s 41667
		SIG_out => pulse
	);

	tmp_val_in <= VALUE_in & "0";


	-- 10-bitni pomikalni register
	Inst_shift_reg: shift_reg 
	PORT MAP(
		CLK_in => CLK_in,
		RST_in => RST_in,
		CE_in	=> pulse,
		WE_in => WE_in,
		VALUE_in => tmp_val_in,
		BIT_out => TXD_out
	);
		
	
	
end Behavioral;

